
/**
 * Simple program to test the various methods of the ByteArray class.
 *
 * @author Roger Lacroix, Capitalware Inc.
 * @version 1.0.0
 * @license Apache 2 License
 */
public class Test_ByteArray
{
   public Test_ByteArray()
   {
      super();

      // "Mary had a little lamb, little lamb."
      byte[] bData = { 'M', 'a', 'r', 'y', ' ', 'h', 'a', 'd', ' ', 'a', ' ', 'l', 'i', 't', 't', 'l', 'e', ' ', 'l', 'a', 'm', 'b', ',', ' ', 'l', 'i', 't', 't', 'l', 'e', ' ', 'l', 'a', 'm', 'b', '.' };
      byte[] bSearch = { 0x68, 0x61, 0x64 }; // had
      byte[] bLamb = { 0x6C, 0x61, 0x6D, 0x62 }; // lamb
      byte[] bMary = { 'M', 'a', 'r', 'y' };
      byte[] bLittle = { 'l', 'i', 't', 't', 'l', 'e' };
      byte[] bPetite = { 'p', 'e', 't', 'i', 't', 'e' };
      
      ByteArray ba = new ByteArray(bData);

      System.out.println("ba.charAt(20)=" + ba.charAt(20));
      System.out.println("ba.byteAt(20)=" + String.format("0x%X", ba.byteAt(20)) + "\n");

      System.out.println("new String(ba.concat(bLamb))=" + new String(ba.concat(bLamb)) + "\n");

      System.out.println("ba.endsWith(bLamb)=" + ba.endsWith(bLamb) + "\n");

      System.out.println("ba.equals(new ByteArray(bLamb))=" + ba.equals(new ByteArray(bLamb)));
      System.out.println("ba.equals(new ByteArray(bData))=" + ba.equals(new ByteArray(bData)) + "\n");

      System.out.println("new String(ba.getBytes(11))=" + new String(ba.getBytes(11)));
      System.out.println("new ByteArray(ba.getBytes(11)).toHex())=" + new ByteArray(ba.getBytes(11)).toHexArray());
      System.out.println("ba.getBytes(11,16)=" + new String(ba.getBytes(11, 16)) + "\n");

      System.out.println("ba.getLength()=" + ba.getLength());
      System.out.println("ba.length()=" + ba.length() + "\n");

      System.out.println("ba.indexOf(bSearch)=" + ba.indexOf(bSearch));
      System.out.println("ba.indexOf(0x64) [d]=" + ba.indexOf((byte) 0x64));
      System.out.println("ba.indexOf(\"lamb\")=" + ba.indexOf("lamb"));
      System.out.println("ba.indexOf('l')=" + ba.indexOf('l'));
      System.out.println("ba.indexOf('l', 20))=" + ba.indexOf('l', 20) + "\n");

      System.out.println("ba.lastIndexOf(bSearch)=" + ba.lastIndexOf(bSearch));
      System.out.println("ba.lastIndexOf(0x64) [d]=" + ba.lastIndexOf((byte) 0x64));
      System.out.println("ba.lastIndexOf(\"lamb\")=" + ba.lastIndexOf("lamb"));
      System.out.println("ba.lastIndexOf('l')=" + ba.lastIndexOf('l'));
      System.out.println("ba.lastIndexOf('l', 20))=" + ba.lastIndexOf('l', 20) + "\n");

      System.out.println("ba.isEmpty()=" + ba.isEmpty() + "\n");

      System.out.println("ba.replace('l','z')=" + new String(ba.replace('l', 'z')));
      System.out.println("ba.replace((byte)0x6C,(byte)0x7A)=" + new String(ba.replace((byte) 0x6C, (byte) 0x7A)) + "\n");
      System.out.println("ba.replace(bLittle, bPetite)=" + new String(ba.replace(bLittle, bPetite)) + "\n");

      byte[] newArray = ba.resize(111);
      System.out.println("byte[] newArray = ba.resize(111)");
      System.out.println("newArray.length=" + newArray.length + " : new String(newArray)=" + new String(newArray) + "\n");

      byte[][] newArray2 = ba.split(' ');
      for (int i = 0; i < newArray2.length; i++)
         System.out.println("new String(newArray2[" + i + "])=" + new String(newArray2[i]));
      System.out.println();

      System.out.println("ba.startsWith(bMary)=" + ba.startsWith(bMary));
      System.out.println("ba.startsWith(bLamb)=" + ba.startsWith(bLamb));
      System.out.println("ba.startsWith(bLamb,18)=" + ba.startsWith(bLamb, 18));
   }

   public static void main(String[] args)
   {
      new Test_ByteArray();
   }
}
